http = require 'http'
url = require 'url'
Server = require './server'
SqiuTaskQueue = require './lib/task-queue'
Queue = require './lib/model/Queue'
qs = require 'qs'
##init
log = console.log
server = new Server
stq = new SqiuTaskQueue
stq.start()
stq.createQueue('seq', 'seq', 1000)
stq.createQueue('con', 'con', 1000)

stq.createQueue('q_push_weilv', 'seq', 1000)
stq.createQueue('q_log_queue', 'con', 1000)
stq.createQueue('fz_weilv_queue', 'seq', 1000)

i = 0


###
tests
http://127.0.0.1:1337/?action=add_task&qname=sdfdsf&url=http://127.0.0.1:1337/?hahah=1
###
class App
	constructor: ->
		##silence is golden
		console.log 'App init'


	##===================================================
	## actions
	##===================================================
	actions:
	## name, len, type[seq,conc]
		create_queue: (req, res)->
			stq.createQueue(req.qp('qname'), req.qp('type'), 1000 + i++)
			#queues = stq.getQueues()
			res.dieWithJSON 0, 'success'
		## name
		remove_queue: (req, res)->
			res.dieWithJSON 0, 'remove_queue'
		## name, len, type[seq,conc]
		update_queue: (req, res)->
			res.dieWithJSON 0, 'update_queue'
		## name
		get_queue: (req, res)->
			res.dieWithJSON 0, 'get_queue'
		## queue_name, url, postdata, prior, options{delay}
		get_queues: (req, res)->
			queues = stq.getQueues()
			res.dieWithJSON 0, queues
		add_task: (req, res)->
			#console.log req.post
			#console.log req.qp('postdata')
			stq.addTask(req.qp('qname'),
				url: req.qp('url')
				postdata: req.qp('postdata')
				prior: req.qp('prior')
				options: req.qp('options'))

			#tasks = stq.getTasks()
			#res.dieWithJSON tasks.length, tasks

			res.dieWithJSON 0, 'success'
		# get_tasks
		get_tasks: (req, res)->
			tasks = stq.getTasks(req.qp('qname'))
			res.dieWithJSON 0, tasks
		clear_tasks: (req, res)->
			res.dieWithJSON 0, 'clear_tasks'

	attachUtil: (req, res)->
		buffer = ''
		urlinfo = url.parse req.url, true
		query = urlinfo.query

		res.json = (o)->
			JSON.stringify(o)
		res.dieWithJSON = (code, msg)->
			msg = '' if !msg?
			res.clear()
			res.finish (res.json {retcode: code, message: msg})
		res.echo = (str)->
			buffer += str
		res.clear = ->
			buffer = ''
		res.finish = (str) ->
			str = '' if !str?
			res.end (buffer + str)
		req.qp = (key, deft = '')->
			if req.post[key]?
				return req.post[key]
			else if !query[key]?
				return deft
			else
				return query[key]

		return {req: req, res: res}

	requestListener: (req, res)->
		console.log '===================================================================='
		console.log('request once. ' + new Date().getTime())
		##===================================================
		## extends utils
		##===================================================
		@.attachUtil req, res
		urlinfo = url.parse req.url, true
		query = urlinfo.query

		if urlinfo.pathname != '/s.q'
			res.writeHead 404
			return res.end('404 Page Not Found.')
		else
			res.writeHead 200, {'Content-Type': 'text/html'}

		#console.log 'get_request_para:'
		#console.log JSON.stringify(query)
		##begin response

		body = ''
		req.on 'data', (data)->
			body += data

		req.on 'end', =>
			req.post = qs.parse(body)
			#req.post = JS
			console.log req.post
			##hook action
			action = req.qp('action')
			action || res.dieWithJSON 1, 'require_action'

			if @actions[action]?
				#console.log 'has_action'
				@actions[action](req, res)
			else
				console.log 'no_found_action'
				res.dieWithJSON 1, 'bad_action'


			res.finish()

server.startApp((app = new App).requestListener.bind(app))
##process.on 'uncaughtException',  (err)->
##console.log err