module.exports = class Collection

	_models: []

	model: null

	constructor: (props)->
		@model = props.model
		@_models = []

	length: ->
		@_models.length

	add: (model)->
		@_models.push model

	remove: ->
		1

	set: ->
		1

	get: (index)->
		@_models[index]

	getAll: ->
		@_models

	query: (where, limit, callback)->
		#console.log 'models\' count is:' + @_models.length
		models = []
		for model, i in @_models
			match = true
			for k, v of where
				if model.get(k) != v
					match = true
					break

			if limit && models.length == limit then break;
			models.push(model) if match
			true
		callback(models)

	getAllData: ->
		datas = []
		datas.push m.data() for m in @_models
		datas

	push: (model)->
		@_models.push model

	pop: ->
		@_models.pop()

	unshift: (model)->
		@_models.unshift model

	shift: ->
		@_models.shift()

	slice: ->
		1
	toJSON: ->
		JSON.stringify @_models

	create: (props)->
		model = new @model(props)
		@add model

	getByDataKey: (key, value)->
		for model in @_models
			return model if model.get(key) == value
		null