util = require 'util'

Date::getMonthTwo = ->
	v = @getMonth() + 1
	v = '0' + v if v < 10
	v

Date::getDateTwo = ->
	v = @getDate()
	v = '0' + v if v < 10
	v

Date::getHoursTwo = ->
	v = @getHours()
	v = '0' + v if v < 10
	v

Date::getMinutesTwo = ->
	v = @getMinutes()
	v = '0' + v if v < 10
	v

Date::getSecondsTwo = ->
	v = @getSeconds()
	v = '0' + v if v < 10
	v


module.exports = class Utils
	@extend = (object, extenders...) ->
		return {} if not object?
		for other in extenders
			for own key, val of other
				if not object[key]? or typeof val isnt "object"
					object[key] = val
				else
					object[key] = deepExtend object[key], val

		object

	@datetime: ->
		d = new Date()
		util.format('%s-%s-%s %s:%s:%s', d.getFullYear(), d.getMonthTwo(), d.getDateTwo(), d.getHoursTwo(),
			d.getMinutesTwo(), d.getSecondsTwo());

	@datetimeWithMicro: ->
		d = new Date()
		util.format('%s-%s-%s %s:%s:%s.%s', d.getFullYear(), d.getMonthTwo(), d.getDateTwo(), d.getHoursTwo(),
			d.getMinutesTwo(), d.getSecondsTwo(), (d.getTime()+'').substr(-3,3));

